Only in kaffe-patched/: gwqt.m4.~1.1.~
Only in kaffe-patched/libraries/javalib: core.29539
Only in kaffe-patched/libraries/javalib: core.31335
Only in kaffe-patched/libraries/javalib/java/awt: GridBagLayout.java.~1.13.~
diff -ur kaffe/libraries/javalib/java/lang/Runtime.java kaffe-patched/libraries/javalib/java/lang/Runtime.java
--- kaffe/libraries/javalib/java/lang/Runtime.java	2003-01-23 03:54:42.000000000 +0100
+++ kaffe-patched/libraries/javalib/java/lang/Runtime.java	2003-03-13 09:30:27.000000000 +0100
@@ -81,6 +81,8 @@
 	throws IOException;
 
 public void exit(int status) {
+	java.util.HashMap.printCounter();
+
 	SecurityManager sm = System.getSecurityManager();
 	if (sm != null)
 		sm.checkExit(status);
Only in kaffe-patched/libraries/javalib/java/lang: Runtime.java.~1.21.~
diff -ur kaffe/libraries/javalib/java/util/HashMap.java kaffe-patched/libraries/javalib/java/util/HashMap.java
--- kaffe/libraries/javalib/java/util/HashMap.java	2002-11-01 12:20:08.000000000 +0100
+++ kaffe-patched/libraries/javalib/java/util/HashMap.java	2003-03-13 09:48:36.000000000 +0100
@@ -19,6 +19,7 @@
 import java.io.ObjectInputStream;
 import java.io.ObjectOutputStream;
 import java.io.ObjectStreamField;
+import java.io.*;
 
 // Simple implementation of a hash table. We keep an array of buckets,
 // where each bucket points to a singly linked list of Entry's (see below).
@@ -51,6 +52,7 @@
 		Entry(Object key, Object value) {
 			super(key, value);
 			next = null;
+			ObjectCounter.count(ObjectCounter.UP);
 		}
 
 		public void changeValue(Object newValue) {
@@ -384,5 +386,51 @@
 	}
 	
 
+
+	public static void printCounter() {
+		System.out.println(ObjectCounter.cache);
+	}
 }
 
+class ObjectCounter {
+	public static final long UP = 1L;
+	public static final long DOWN = -1L;
+
+	public static Map cache = new TreeMap();
+
+	private static Throwable t = new Throwable();
+	private static CharArrayWriter caw = new CharArrayWriter();
+	private static PrintWriter pw ;
+
+
+	private static final int SKIP = 200;
+	private static int skipcount;
+
+	public static synchronized void count(long amount) {
+		if (++skipcount < SKIP) {
+			return;
+		}
+
+		if (pw == null) {
+			pw = new PrintWriter(caw);
+		}
+
+		/* get stack trace */
+		t.fillInStackTrace();
+
+		/* get stack trace string */
+		caw.reset();
+		t.printStackTrace(pw);
+		String trace = caw.toString();
+
+		/* store in hash map and increase the counter */
+		Long count = (Long) cache.get(trace);
+
+		if (count == null) {
+			cache.put(trace, new Long(0));
+		}
+		else {
+			cache.put(trace, new Long(count.intValue() + amount));
+		}
+	}
+}
Only in kaffe-patched/libraries/javalib/java/util: HashMap.java.~1.17.~
Binary files kaffe/libraries/javalib/Klasses.jar.bootstrap and kaffe-patched/libraries/javalib/Klasses.jar.bootstrap differ
Binary files kaffe/libraries/javalib/Klasses.jar.bootstrap.save and kaffe-patched/libraries/javalib/Klasses.jar.bootstrap.save differ
